public class AVLTree<D> implements Dictionary<D> {
   AVLNode<D> root;

   /**
    * finds a node with a given key in this tree 
    * @param key
    * @return null, if the root is null; 
    *    a node with key, if this exists;
    *    a leaf below which the key has to be inserted, otherwise 
    */
   AVLNode<D> find(int key) {
      AVLNode<D> current = this.root;
      AVLNode<D> previous = null;
      while (current != null) {
         previous = current;
         if (key < current.key) {
            current = current.left;
         } else if (key == current.key) {
            return current;
         } else {
            current = current.right;
         }
      }
      return previous; 
   }

   public D get(int key) {
      AVLNode<D> node = find(key);
      if (node != null && node.key == key) {
         return node.data;
      } else {
         return null;
      }
   }

   public void put(int key, D data) {
      AVLNode<D> node = find(key);
      if (node == null) { // root is null
         this.root = new AVLNode<D>(key,data,null);
      } else if (node.key == key) { // overwrite
         node.data = data;
      } else { // new node below node
         AVLNode<D> newNode = new AVLNode<D>(key,data,node);
         if (node.hdiff == -1) {
            node.hdiff = 0;
            node.right = newNode;
         } else if (node.hdiff == 1) {
            node.hdiff = 0;
            node.left = newNode;
         } else { // n.hdiff = 0
            if (key < node.key) {
               node.left = newNode;
               node.hdiff = -1;
            } else {
               node.right = newNode;
               node.hdiff = 1;
            }
         }
         if (node.hdiff != 0) {
            balGrow(node);
         }
      }
   }

   
   /**
    * does not update the balance-informations
    */
   void rotateRight(AVLNode<D> p) {
       // can be ignored
   }

   /**
    * does not update the balance-informations
    */
   void rotateLeft(AVLNode<D> p) {
      // TODO 
   }
   
   void balGrow(AVLNode<D> n) {
      // TODO
   }

   
   public void remove(int key) {
      throw new RuntimeException("Not yet supported, ignore");
   }

   public Iterator<D> iterator() {      
      throw new RuntimeException("As in bintree, ignore");
   }

}
